Index: /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs	(revision 10020)
+++ /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs	(revision 10021)
@@ -20,6 +20,7 @@
 #endregion
 
+
 namespace HeuristicLab.Problems.Instances.Views {
-  partial class ProblemInstanceProviderViewGeneric<T> {
+  partial class ProblemInstanceProviderView<T> {
     /// <summary> 
     /// Required designer variable.
@@ -45,19 +46,22 @@
     /// </summary>
     private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.instanceLabel = new System.Windows.Forms.Label();
       this.instancesComboBox = new System.Windows.Forms.ComboBox();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
+      this.instanceLabel = new System.Windows.Forms.Label();
+      this.splitContainer2 = new System.Windows.Forms.SplitContainer();
+      this.exportButton = new System.Windows.Forms.Button();
+      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
+      this.importButton = new System.Windows.Forms.Button();
+      this.libraryInfoButton = new System.Windows.Forms.Button();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer2)).BeginInit();
+      this.splitContainer2.Panel1.SuspendLayout();
+      this.splitContainer2.Panel2.SuspendLayout();
+      this.splitContainer2.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
+      this.splitContainer1.Panel1.SuspendLayout();
+      this.splitContainer1.Panel2.SuspendLayout();
+      this.splitContainer1.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // instanceLabel
-      // 
-      this.instanceLabel.AutoSize = true;
-      this.instanceLabel.Location = new System.Drawing.Point(3, 4);
-      this.instanceLabel.Name = "instanceLabel";
-      this.instanceLabel.Size = new System.Drawing.Size(51, 13);
-      this.instanceLabel.TabIndex = 4;
-      this.instanceLabel.Text = "Instance:";
       // 
       // instancesComboBox
@@ -67,10 +71,10 @@
       this.instancesComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.instancesComboBox.FormattingEnabled = true;
-      this.instancesComboBox.Location = new System.Drawing.Point(60, 1);
+      this.instancesComboBox.Location = new System.Drawing.Point(60, 2);
       this.instancesComboBox.Name = "instancesComboBox";
-      this.instancesComboBox.Size = new System.Drawing.Size(632, 21);
+      this.instancesComboBox.Size = new System.Drawing.Size(540, 21);
       this.instancesComboBox.TabIndex = 7;
+      this.instancesComboBox.SelectionChangeCommitted += new System.EventHandler(this.instancesComboBox_SelectionChangeCommitted);
       this.instancesComboBox.DataSourceChanged += new System.EventHandler(this.instancesComboBox_DataSourceChanged);
-      this.instancesComboBox.SelectionChangeCommitted += new System.EventHandler(instancesComboBox_SelectionChangeCommitted);
       // 
       // openFileDialog
@@ -83,14 +87,99 @@
       this.saveFileDialog.Title = "Save RegressionInstance...";
       // 
+      // instanceLabel
+      // 
+      this.instanceLabel.AutoSize = true;
+      this.instanceLabel.Location = new System.Drawing.Point(3, 5);
+      this.instanceLabel.Name = "instanceLabel";
+      this.instanceLabel.Size = new System.Drawing.Size(51, 13);
+      this.instanceLabel.TabIndex = 4;
+      this.instanceLabel.Text = "Instance:";
+      // 
+      // splitContainer2
+      // 
+      this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer2.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
+      this.splitContainer2.IsSplitterFixed = true;
+      this.splitContainer2.Location = new System.Drawing.Point(0, 0);
+      this.splitContainer2.Name = "splitContainer2";
+      // 
+      // splitContainer2.Panel1
+      // 
+      this.splitContainer2.Panel1.Controls.Add(this.exportButton);
+      // 
+      // splitContainer2.Panel2
+      // 
+      this.splitContainer2.Panel2.Controls.Add(this.instanceLabel);
+      this.splitContainer2.Panel2.Controls.Add(this.instancesComboBox);
+      this.splitContainer2.Size = new System.Drawing.Size(632, 23);
+      this.splitContainer2.SplitterDistance = 25;
+      this.splitContainer2.TabIndex = 21;
+      // 
+      // exportButton
+      // 
+      this.exportButton.Location = new System.Drawing.Point(1, 0);
+      this.exportButton.Name = "exportButton";
+      this.exportButton.Size = new System.Drawing.Size(24, 24);
+      this.exportButton.TabIndex = 20;
+      this.exportButton.Text = "Export";
+      this.exportButton.UseVisualStyleBackColor = true;
+      this.exportButton.Click += new System.EventHandler(exportButton_Click);
+      // 
+      // splitContainer1
+      // 
+      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer1.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
+      this.splitContainer1.IsSplitterFixed = true;
+      this.splitContainer1.Location = new System.Drawing.Point(33, -1);
+      this.splitContainer1.Name = "splitContainer1";
+      // 
+      // splitContainer1.Panel1
+      // 
+      this.splitContainer1.Panel1.Controls.Add(this.importButton);
+      // 
+      // splitContainer1.Panel2
+      // 
+      this.splitContainer1.Panel2.Controls.Add(this.splitContainer2);
+      this.splitContainer1.Size = new System.Drawing.Size(661, 23);
+      this.splitContainer1.SplitterDistance = 25;
+      this.splitContainer1.TabIndex = 21;
+      // 
+      // importButton
+      // 
+      this.importButton.Location = new System.Drawing.Point(0, 0);
+      this.importButton.Name = "importButton";
+      this.importButton.Size = new System.Drawing.Size(24, 24);
+      this.importButton.TabIndex = 19;
+      this.importButton.Text = "Import";
+      this.importButton.UseVisualStyleBackColor = true;
+      this.importButton.Click += new System.EventHandler(importButton_Click);
+      // 
+      // libraryInfoButton
+      // 
+      this.libraryInfoButton.Location = new System.Drawing.Point(3, -1);
+      this.libraryInfoButton.Name = "libraryInfoButton";
+      this.libraryInfoButton.Size = new System.Drawing.Size(24, 24);
+      this.libraryInfoButton.TabIndex = 22;
+      this.libraryInfoButton.Text = "Info";
+      this.libraryInfoButton.UseVisualStyleBackColor = true;
+      this.libraryInfoButton.Click += new System.EventHandler(this.libraryInfoButton_Click);
+      // 
       // ProblemInstanceProviderViewGeneric
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.instanceLabel);
-      this.Controls.Add(this.instancesComboBox);
+      this.Controls.Add(this.libraryInfoButton);
+      this.Controls.Add(this.splitContainer1);
       this.Name = "ProblemInstanceProviderViewGeneric";
-      this.Size = new System.Drawing.Size(694, 21);
+      this.splitContainer2.Panel1.ResumeLayout(false);
+      this.splitContainer2.Panel2.ResumeLayout(false);
+      this.splitContainer2.Panel2.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer2)).EndInit();
+      this.splitContainer2.ResumeLayout(false);
+      this.splitContainer1.Panel1.ResumeLayout(false);
+      this.splitContainer1.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
+      this.splitContainer1.ResumeLayout(false);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -98,7 +187,12 @@
 
     protected System.Windows.Forms.OpenFileDialog openFileDialog;
-    protected System.Windows.Forms.Label instanceLabel;
     protected System.Windows.Forms.ComboBox instancesComboBox;
     protected System.Windows.Forms.SaveFileDialog saveFileDialog;
+    protected System.Windows.Forms.Label instanceLabel;
+    protected System.Windows.Forms.SplitContainer splitContainer2;
+    protected System.Windows.Forms.SplitContainer splitContainer1;
+    protected System.Windows.Forms.Button libraryInfoButton;
+    protected System.Windows.Forms.Button importButton;
+    protected System.Windows.Forms.Button exportButton;
   }
 }
Index: /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs	(revision 10020)
+++ /stable/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs	(revision 10021)
@@ -21,8 +21,10 @@
 
 using System;
-using System.ComponentModel;
+using System.Diagnostics;
+using System.IO;
 using System.Linq;
 using System.Threading.Tasks;
 using System.Windows.Forms;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
@@ -32,5 +34,5 @@
   [View("ProblemInstanceProviderViewGeneric")]
   [Content(typeof(IProblemInstanceProvider<>), IsDefaultView = true)]
-  public partial class ProblemInstanceProviderViewGeneric<T> : ProblemInstanceProviderView {
+  public partial class ProblemInstanceProviderView<T> : ProblemInstanceProviderView {
 
     public new IProblemInstanceProvider<T> Content {
@@ -39,7 +41,7 @@
     }
 
-    private IProblemInstanceConsumer<T> GenericConsumer { get { return Consumer as IProblemInstanceConsumer<T>; } }
-
-    private IProblemInstanceConsumer consumer;
+    #region Importer & Exporter
+    protected IProblemInstanceConsumer<T> GenericConsumer { get { return Consumer as IProblemInstanceConsumer<T>; } }
+    protected IProblemInstanceConsumer consumer;
     public override IProblemInstanceConsumer Consumer {
       get { return consumer; }
@@ -47,9 +49,27 @@
         consumer = value;
         SetEnabledStateOfControls();
+        SetTooltip();
       }
     }
 
-    public ProblemInstanceProviderViewGeneric() {
+    protected IProblemInstanceExporter<T> GenericExporter { get { return Exporter as IProblemInstanceExporter<T>; } }
+    protected IProblemInstanceExporter exporter;
+    public override IProblemInstanceExporter Exporter {
+      get { return exporter; }
+      set {
+        exporter = value;
+        SetEnabledStateOfControls();
+      }
+    }
+    #endregion
+
+    public ProblemInstanceProviderView() {
       InitializeComponent();
+      importButton.Text = String.Empty;
+      importButton.Image = VSImageLibrary.Open;
+      exportButton.Text = String.Empty;
+      exportButton.Image = VSImageLibrary.SaveAs;
+      libraryInfoButton.Text = String.Empty;
+      libraryInfoButton.Image = VSImageLibrary.Help;
     }
 
@@ -65,4 +85,5 @@
         instancesComboBox.SelectedIndex = -1;
       }
+      SetTooltip();
     }
 
@@ -80,4 +101,9 @@
       base.SetEnabledStateOfControls();
       instancesComboBox.Enabled = !ReadOnly && !Locked && Content != null && GenericConsumer != null;
+      libraryInfoButton.Enabled = Content != null && Content.WebLink != null;
+      importButton.Enabled = !ReadOnly && !Locked && Content != null && GenericConsumer != null && Content.CanImportData;
+      splitContainer1.Panel1Collapsed = !importButton.Enabled;
+      exportButton.Enabled = !ReadOnly && !Locked && Content != null && GenericExporter != null && Content.CanExportData;
+      splitContainer2.Panel1Collapsed = !exportButton.Enabled;
     }
 
@@ -89,5 +115,5 @@
     }
 
-    private void instancesComboBox_SelectionChangeCommitted(object sender, System.EventArgs e) {
+    protected virtual void instancesComboBox_SelectionChangeCommitted(object sender, EventArgs e) {
       toolTip.SetToolTip(instancesComboBox, String.Empty);
       if (instancesComboBox.SelectedIndex >= 0) {
@@ -98,38 +124,64 @@
         // lock active view and show progress bar
         mainForm.AddOperationProgressToContent(activeView.Content, "Loading problem instance.");
-        // continuation for removing the progess bar from the active view
-        Action<Task> removeProgressFromContent = (_) => mainForm.RemoveOperationProgressFromContent(activeView.Content);
 
-        // task structure:
-        // loadFromProvider
-        // |
-        // +-> on fault -> show error dialog -> remove progress bar
-        // |
-        // `-> success  -> loadToProblem
-        //                 |
-        //                 +-> on fault -> show error dialog -> remove progress bar
-        //                 |
-        //                 `-> success -> set tool tip -> remove progress bar
-        var loadFromProvider = new Task<T>(() => Content.LoadData(descriptor));
+        Task.Factory.StartNew(() => {
+          T data;
+          try {
+            data = Content.LoadData(descriptor);
+          } catch (Exception ex) {
+            ErrorHandling.ShowErrorDialog(String.Format("Could not load the problem instance {0}", descriptor.Name), ex);
+            mainForm.RemoveOperationProgressFromContent(activeView.Content);
+            return;
+          }
+          try {
+            GenericConsumer.Load(data);
+          } catch (Exception ex) {
+            ErrorHandling.ShowErrorDialog(String.Format("This problem does not support loading the instance {0}", descriptor.Name), ex);
+          } finally {
+            mainForm.RemoveOperationProgressFromContent(activeView.Content);
+          }
+        });
+      }
+    }
 
-        // success
-        var loadToProblem = loadFromProvider
-          .ContinueWith(task => GenericConsumer.Load(task.Result), TaskContinuationOptions.OnlyOnRanToCompletion);
-        // on error 
-        loadFromProvider
-          .ContinueWith(task => { ErrorHandling.ShowErrorDialog(String.Format("Could not load the problem instance {0}", descriptor.Name), task.Exception); }, TaskContinuationOptions.OnlyOnFaulted)
-          .ContinueWith(removeProgressFromContent);
+    private void libraryInfoButton_Click(object sender, EventArgs e) {
+      Process.Start(Content.WebLink.ToString());
+    }
 
-        // success
-        loadToProblem
-          .ContinueWith(task => toolTip.SetToolTip(instancesComboBox, descriptor.Description), TaskContinuationOptions.OnlyOnRanToCompletion)
-          .ContinueWith(removeProgressFromContent);
-        // on error
-        loadToProblem.ContinueWith(task => { ErrorHandling.ShowErrorDialog(String.Format("This problem does not support loading the instance {0}", descriptor.Name), task.Exception); }, TaskContinuationOptions.OnlyOnFaulted)
-        .ContinueWith(removeProgressFromContent);
+    protected virtual void importButton_Click(object sender, EventArgs e) {
+      openFileDialog.FileName = Content.Name + " instance";
+      if (openFileDialog.ShowDialog() == DialogResult.OK) {
+        T instance = default(T);
+        try {
+          instance = Content.ImportData(openFileDialog.FileName);
+        } catch (Exception ex) {
+          MessageBox.Show(String.Format("There was an error parsing the file: {0}", Environment.NewLine + ex.Message), "Error while parsing", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          return;
+        }
+        try {
+          GenericConsumer.Load(instance);
+          instancesComboBox.SelectedIndex = -1;
+        } catch (Exception ex) {
+          MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", Path.GetFileName(openFileDialog.FileName), Environment.NewLine + ex.Message), "Cannot load instance");
+        }
+      }
+    }
 
-        // start async loading task
-        loadFromProvider.Start();
+    protected virtual void exportButton_Click(object sender, EventArgs e) {
+      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          Content.ExportData(GenericExporter.Export(), saveFileDialog.FileName);
+        } catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
       }
+    }
+
+    protected override void SetTooltip() {
+      toolTip.SetToolTip(importButton, "Import a " + GetProblemType() + " from a file in the " + GetProviderFormatInfo() + " format.");
+      toolTip.SetToolTip(exportButton, "Export currently loaded " + GetProblemType() + " to a file in the " + GetProviderFormatInfo() + " format.");
+      if (Content != null && Content.WebLink != null)
+        toolTip.SetToolTip(libraryInfoButton, "Browse to " + Content.WebLink);
+      else toolTip.SetToolTip(libraryInfoButton, "Library does not have a web reference.");
     }
   }
Index: /stable/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs
===================================================================
--- /stable/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 10020)
+++ /stable/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 10021)
@@ -71,8 +71,8 @@
       // ProblemInstanceConsumerViewHost
       // 
-      this.ProblemInstanceConsumerViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
-      this.ProblemInstanceConsumerViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.ProblemInstanceConsumerViewHost.Location = new System.Drawing.Point(0, 0);
-      this.ProblemInstanceConsumerViewHost.Size = new System.Drawing.Size(511, 26);
+      this.problemInstanceProviderViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
+      this.problemInstanceProviderViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.problemInstanceProviderViewHost.Location = new System.Drawing.Point(0, 0);
+      this.problemInstanceProviderViewHost.Size = new System.Drawing.Size(511, 26);
       // 
       // parameterCollectionView
@@ -95,6 +95,6 @@
       // problemTabControl
       // 
-      this.problemTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.problemTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.problemTabControl.Controls.Add(this.problemTabPage);
